diff --git a/configure.ac b/configure.ac
index 080f0fd8b0..9c688d750e 100644
--- a/configure.ac
+++ b/configure.ac
@@ -1694,6 +1694,17 @@ AC_ARG_ENABLE(kafka_tests,
 )
 AM_CONDITIONAL(ENABLE_KAFKA_TESTS, test x$enable_kafka_tests = xyes)
 
+AC_ARG_ENABLE(kafka_static,
+        [AS_HELP_STRING([--enable-kafka-static],[Enable static library linking for Kafka modules. Removes dependency for rdkafka.so. @<:@default=no@:>@])],
+        [case "${enableval}" in
+         yes) enable_kafka_static="yes" ;;
+          no) enable_kafka_static="no" ;;
+           *) AC_MSG_ERROR(bad value ${enableval} for --enable-kafka-static) ;;
+         esac],
+        [enable_kafka_static=no]
+)
+AM_CONDITIONAL(ENABLE_KAFKA_STATIC, test x$enable_kafka_static = xyes)
+
 # omkafka works with older library
 if test "x$enable_omkafka" = "xyes"; then
 	PKG_CHECK_MODULES([LIBRDKAFKA], [rdkafka],, [
@@ -1706,15 +1717,19 @@ if test "x$enable_omkafka" = "xyes"; then
 			])
 		])
 	])
-	PKG_CHECK_MODULES([LIBLZ4], [liblz4],, [
-		AC_CHECK_LIB([lz4], [LZ4_compress], [
-			AC_MSG_WARN([liblz4 is missing but library present, using -llz4])
-			LIBRDKAFKA_LIBS=-llz4
-		], [
-			AC_MSG_ERROR([could not find liblz4 library])
-		])
-	])
 	AC_CHECK_HEADERS([librdkafka/rdkafka.h])
+
+	# Add additional dependencies if statically linking rdkafka
+	if test "x$enable_kafka_static" = "xyes"; then
+		PKG_CHECK_MODULES([LIBLZ4], [liblz4],, [
+			AC_CHECK_LIB([lz4], [LZ4_compress], [
+				AC_MSG_WARN([liblz4 is missing but library present, using -llz4])
+				LIBRDKAFKA_LIBS=-llz4
+			], [
+				AC_MSG_ERROR([could not find liblz4 library])
+			])
+		])
+	fi
 fi
 
 # imkafka needs newer library
@@ -1727,16 +1742,19 @@ if test "x$enable_imkafka" = "xyes"; then
 			AC_MSG_ERROR([could not find rdkafka library])
 		])
 	])
-	PKG_CHECK_MODULES([LIBLZ4], [liblz4],, [
-		AC_CHECK_LIB([lz4], [LZ4_compress], [
-			AC_MSG_WARN([liblz4 is missing but library present, using -llz4])
-			LIBRDKAFKA_LIBS=-llz4
-		], [
-			AC_MSG_ERROR([could not find liblz4 library])
-		])
-	])
-
 	AC_CHECK_HEADERS([librdkafka/rdkafka.h])
+
+	# Add additional dependencies if statically linking rdkafka
+	if test "x$enable_kafka_static" = "xyes"; then
+		PKG_CHECK_MODULES([LIBLZ4], [liblz4],, [
+			AC_CHECK_LIB([lz4], [LZ4_compress], [
+				AC_MSG_WARN([liblz4 is missing but library present, using -llz4])
+				LIBRDKAFKA_LIBS=-llz4
+			], [
+				AC_MSG_ERROR([could not find liblz4 library])
+			])
+		])
+	fi
 fi
 
 if test "x$enable_omkafka" = "xyes" && test "x$enable_imkafka" = "xyes"; then
@@ -2126,6 +2144,7 @@ echo "    mmrm1stspace module enabled:              $enable_mmrm1stspace"
 echo "    message counting support enabled:         $enable_mmcount"
 echo "    mmfields enabled:                         $enable_mmfields"
 echo "    liblogging-stdlog support enabled:        $enable_liblogging_stdlog"
+echo "    kafka static linking enabled:             $enable_kafka_static"
 echo
 echo "---{ input plugins }---"
 echo "    Klog functionality enabled:               $enable_klog ($os_type)"
diff --git a/plugins/imkafka/Makefile.am b/plugins/imkafka/Makefile.am
index f3cfadccff..571bc3c811 100644
--- a/plugins/imkafka/Makefile.am
+++ b/plugins/imkafka/Makefile.am
@@ -2,7 +2,12 @@ pkglib_LTLIBRARIES = imkafka.la
 
 imkafka_la_SOURCES = imkafka.c
 imkafka_la_CPPFLAGS = -I$(top_srcdir) $(RSRT_CFLAGS) $(PTHREADS_CFLAGS)
-imkafka_la_LDFLAGS = -module -avoid-version -Wl,--whole-archive -l:librdkafka.a -Wl,--no-whole-archive -lssl -lpthread -lcrypto -lsasl2 -lz -llz4 -lrt # Static Linking now $(LIBRDKAFKA_LIBS) 
+if !ENABLE_KAFKA_STATIC
+imkafka_la_LDFLAGS = -module -avoid-version $(LIBRDKAFKA_LIBS)
+endif
+if ENABLE_KAFKA_STATIC
+imkafka_la_LDFLAGS = -module -avoid-version -Wl,--whole-archive -l:librdkafka.a -Wl,--no-whole-archive -lssl -lpthread -lcrypto -lsasl2 -lz -llz4 -lrt # Static Linking now $(LIBRDKAFKA_LIBS)
+endif
 imkafka_la_LIBADD = 
 
 EXTRA_DIST = 
diff --git a/plugins/omkafka/Makefile.am b/plugins/omkafka/Makefile.am
index b87a3a6b05..fe962f9f18 100644
--- a/plugins/omkafka/Makefile.am
+++ b/plugins/omkafka/Makefile.am
@@ -2,7 +2,12 @@ pkglib_LTLIBRARIES = omkafka.la
 
 omkafka_la_SOURCES = omkafka.c
 omkafka_la_CPPFLAGS =  $(RSRT_CFLAGS) $(PTHREADS_CFLAGS)
-omkafka_la_LDFLAGS = -module -avoid-version -Wl,--whole-archive -l:librdkafka.a -Wl,--no-whole-archive -lssl -lpthread -lcrypto -lsasl2 -lz -llz4 -lrt # Static Linking now $(LIBRDKAFKA_LIBS) 
+if !ENABLE_KAFKA_STATIC
+omkafka_la_LDFLAGS = -module -avoid-version $(LIBRDKAFKA_LIBS)
+endif
+if ENABLE_KAFKA_STATIC
+omkafka_la_LDFLAGS = -module -avoid-version -Wl,--whole-archive -l:librdkafka.a -Wl,--no-whole-archive -lssl -lpthread -lcrypto -lsasl2 -lz -llz4 -lrt # Static Linking now $(LIBRDKAFKA_LIBS)
+endif
 omkafka_la_LIBADD = 
 
 EXTRA_DIST = 
diff --git a/plugins/omkafka/omkafka.c b/plugins/omkafka/omkafka.c
index 1148d5bb50..a3efb3105d 100644
--- a/plugins/omkafka/omkafka.c
+++ b/plugins/omkafka/omkafka.c
@@ -299,7 +299,7 @@ rd_kafka_topic_t** topic) {
 	if(topicconf == NULL) {
 		errmsg.LogError(0, RS_RET_KAFKA_ERROR,
 						"omkafka: error creating kafka topic conf obj: %s\n",
-						rd_kafka_err2str(rd_kafka_errno2err(errno)));
+						rd_kafka_err2str(rd_kafka_last_error()));
 		ABORT_FINALIZE(RS_RET_KAFKA_ERROR);
 	}
 	for(int i = 0 ; i < pData->nTopicConfParams ; ++i) {
@@ -324,7 +324,7 @@ rd_kafka_topic_t** topic) {
 	if(rkt == NULL) {
 		errmsg.LogError(0, RS_RET_KAFKA_ERROR,
 						"omkafka: error creating kafka topic: %s\n",
-						rd_kafka_err2str(rd_kafka_errno2err(errno)));
+						rd_kafka_err2str(rd_kafka_last_error()));
 		ABORT_FINALIZE(RS_RET_KAFKA_ERROR);
 	}
 	*topic = rkt;
@@ -548,6 +548,7 @@ writeKafka(instanceData *pData, uchar *msg, uchar *msgTimestamp, uchar *topic)
 	const int partition = getPartition(pData);
 	rd_kafka_topic_t *rkt = NULL;
 	pthread_rwlock_t *dynTopicLock = NULL;
+	failedmsg_entry* fmsgEntry;
 #if RD_KAFKA_VERSION >= 0x00090400
 	rd_kafka_resp_err_t msg_kafka_response;
 	int64_t ttMsgTimestamp;
@@ -595,11 +596,27 @@ writeKafka(instanceData *pData, uchar *msg, uchar *msgTimestamp, uchar *topic)
 	}
 
 	if (msg_kafka_response != RD_KAFKA_RESP_ERR_NO_ERROR ) {
-		errmsg.LogError(0, RS_RET_KAFKA_PRODUCE_ERR,
+		/* Put into kafka queue, again if configured! */
+		if (pData->bResubmitOnFailure) {
+			DBGPRINTF("omkafka: Failed to produce to topic '%s' (rd_kafka_producev)"
+			"partition %d: '%d/%s' - adding MSG '%s' to failed for RETRY!\n",
+				rd_kafka_topic_name(rkt), partition, msg_kafka_response,
+				rd_kafka_err2str(msg_kafka_response), msg);
+
+			/* Create new Listitem */
+			CHKmalloc(fmsgEntry = malloc(sizeof(struct s_failedmsg_entry)));
+			fmsgEntry->payload = (uchar*)strdup((char*)msg);
+			fmsgEntry->topicname = (uchar*)strdup(rd_kafka_topic_name(rkt));
+
+			/* Insert at the head. */
+			LIST_INSERT_HEAD(&pData->failedmsg_head, fmsgEntry, entries);
+		} else {
+			errmsg.LogError(0, RS_RET_KAFKA_PRODUCE_ERR,
 			"omkafka: Failed to produce to topic '%s' (rd_kafka_producev)"
 			"partition %d: %d/%s\n",
 			rd_kafka_topic_name(rkt), partition, msg_kafka_response,
 			rd_kafka_err2str(msg_kafka_response));
+		}
 	}
 #else
 
@@ -610,11 +627,27 @@ writeKafka(instanceData *pData, uchar *msg, uchar *msgTimestamp, uchar *topic)
 										  pData->key == NULL ? 0 : strlen((char*)pData->key),
 										  NULL);
 	if(msg_enqueue_status == -1) {
-		errmsg.LogError(0, RS_RET_KAFKA_PRODUCE_ERR,
+		/* Put into kafka queue, again if configured! */
+		if (pData->bResubmitOnFailure) {
+			DBGPRINTF("omkafka: Failed to produce to topic '%s' (rd_kafka_produce)"
+			"partition %d: '%d/%s' - adding MSG '%s' to failed for RETRY!\n",
+				rd_kafka_topic_name(rkt), partition, rd_kafka_last_error(),
+				rd_kafka_err2str(rd_kafka_last_error()), msg);
+
+			/* Create new Listitem */
+			CHKmalloc(fmsgEntry = malloc(sizeof(struct s_failedmsg_entry)));
+			fmsgEntry->payload = (uchar*)strdup((char*)msg);
+			fmsgEntry->topicname = (uchar*)strdup(rd_kafka_topic_name(rkt));
+
+			/* Insert at the head. */
+			LIST_INSERT_HEAD(&pData->failedmsg_head, fmsgEntry, entries);
+		} else {
+			errmsg.LogError(0, RS_RET_KAFKA_PRODUCE_ERR,
 			"omkafka: Failed to produce to topic '%s' (rd_kafka_produce) "
 			"partition %d: %d/%s\n",
-			rd_kafka_topic_name(rkt), partition, errno,
-			rd_kafka_err2str(rd_kafka_errno2err(errno)));
+			rd_kafka_topic_name(rkt), partition, rd_kafka_last_error(),
+			rd_kafka_err2str(rd_kafka_last_error()));
+		}
 	}
 #endif
 
@@ -820,7 +853,7 @@ openKafka(instanceData *const __restrict__ pData)
 	if(conf == NULL) {
 		errmsg.LogError(0, RS_RET_KAFKA_ERROR,
 			"omkafka: error creating kafka conf obj: %s\n",
-			rd_kafka_err2str(rd_kafka_errno2err(errno)));
+			rd_kafka_err2str(rd_kafka_last_error()));
 		ABORT_FINALIZE(RS_RET_KAFKA_ERROR);
 	}
 
diff --git a/tests/Makefile.am b/tests/Makefile.am
index c8b7d5b43c..bea15691d1 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -330,10 +330,12 @@ endif
 if ENABLE_OMKAFKA
 if ENABLE_IMKAFKA
 if ENABLE_KAFKA_TESTS
-#TESTS += \
-# @alorbach: these tests do not work out. Please fix and re-enable.
-#	sndrcv_kafka.sh \
+TESTS += \
+	sndrcv_kafka.sh 
+# Tests below need to be stable first!
 #	sndrcv_kafka_multi.sh
+#	sndrcv_kafka_fail.sh
+#	sndrcv_kafka_failresume.sh
 endif
 endif
 endif
@@ -1335,12 +1337,20 @@ EXTRA_DIST= \
 	testsuites/mysql-actq-mt.conf \
 	sndrcv_kafka.sh \
 	sndrcv_kafka_multi.sh \
+	sndrcv_kafka_fail.sh \
+	sndrcv_kafka_failresume.sh \
+	testsuites/sndrcv_kafka_rcvr.conf \
+	testsuites/sndrcv_kafka_sender.conf \
+	testsuites/sndrcv_kafka_multi_rcvr.conf \
+	testsuites/sndrcv_kafka_multi_sender.conf \
 	testsuites/kafka-server.properties \
+	testsuites/kafka-server.dep_wrk1.properties \
+	testsuites/kafka-server.dep_wrk2.properties \
+	testsuites/kafka-server.dep_wrk3.properties \
 	testsuites/zoo.cfg \
-	omkafka_static.sh \
-	testsuites/omkafka_static.conf \
-	omkafka_multiple.sh \
-	testsuites/omkafka_multiple.conf \
+	testsuites/zoo.dep_wrk1.cfg \
+	testsuites/zoo.dep_wrk2.cfg \
+	testsuites/zoo.dep_wrk3.cfg \
 	mmpstrucdata.sh \
 	mmpstrucdata-vg.sh \
 	testsuites/mmpstrucdata.conf \
diff --git a/tests/diag.sh b/tests/diag.sh
index 6d7ef5f0ff..fdd66de99c 100755
--- a/tests/diag.sh
+++ b/tests/diag.sh
@@ -603,7 +603,7 @@ case $1 in
 
 		if [ ! -f $dep_zk_cached_file ]; then
 				echo "Dependency-cache does not have zookeeper package, did you download dependencies?"
-				exit 1
+				exit 77
 		fi
 		if [ ! -d $dep_work_dir ]; then
 				echo "Creating dependency working directory"
@@ -631,7 +631,7 @@ case $1 in
 
 		if [ ! -f $dep_kafka_cached_file ]; then
 				echo "Dependency-cache does not have kafka package, did you download dependencies?"
-				exit 1
+				exit 77
 		fi
 		if [ ! -d $dep_work_dir ]; then
 				echo "Creating dependency working directory"
@@ -660,7 +660,7 @@ case $1 in
 				echo "Kafka instance $dep_work_kafka_config started with PID $kafkapid"
 			else
 				echo "Failed to start Kafka instance for $dep_work_kafka_config"
-				. $srcdir/diag.sh error-exit 1
+				. $srcdir/diag.sh error-exit 77
 			fi
 		fi
 		;;
diff --git a/tests/omkafka_multiple.sh b/tests/omkafka_multiple.sh
deleted file mode 100755
index b7039e240f..0000000000
--- a/tests/omkafka_multiple.sh
+++ /dev/null
@@ -1,51 +0,0 @@
-#!/bin/bash
-# added 2017-03-17 by Andre Lorbach
-# This file is part of the rsyslog project, released under ASL 2.0
-. $srcdir/diag.sh init
-. $srcdir/diag.sh download-kafka
-#. $srcdir/diag.sh start-kafka '.dep_wrk1'
-. $srcdir/diag.sh start-kafka '.dep_wrk2'
-. $srcdir/diag.sh start-kafka '.dep_wrk3'
-#. $srcdir/diag.sh create-kafka-topic 'static' '.dep_wrk1' '2181'
-. $srcdir/diag.sh create-kafka-topic 'static' '.dep_wrk2' '2182'
-. $srcdir/diag.sh create-kafka-topic 'static' '.dep_wrk3' '2183'
-
-. $srcdir/diag.sh generate-conf
-. $srcdir/diag.sh add-conf '
-module(load="../plugins/omkafka/.libs/omkafka")
-
-ruleset(name="stats") {
-  action(type="omfile" file="./rsyslog.out.stats.log")
-}
-
-module(load="../plugins/impstats/.libs/impstats" interval="1" severity="7" resetCounters="on" Ruleset="stats" bracketing="on")
-
-template(name="outfmt" type="string" string="%msg%\n")
-
-if ($msg contains "msgnum") then {
-	 action(name="kafka-fwd" type="omkafka" topic="static" broker=["localhost:9092", "localhost:9093", "localhost:9094"] template="outfmt" partitions.auto="on")
-#	 action(name="kafka-fwd" type="omkafka" topic="static" broker="localhost:9092" template="outfmt" partitions.auto="on")
-#	 action(name="kafka-fwd" type="omkafka" topic="static" broker="localhost:9093" template="outfmt" partitions.auto="on")
-#	 action(name="kafka-fwd" type="omkafka" topic="static" broker="localhost:9094" template="outfmt" partitions.auto="on")
-}
-'
-. $srcdir/diag.sh startup omkafka_multiple.conf
-. $srcdir/diag.sh wait-for-stats-flush 'rsyslog.out.stats.log'
-. $srcdir/diag.sh injectmsg  0 1000 #100000
-. $srcdir/diag.sh wait-queueempty
-. $srcdir/diag.sh wait-for-stats-flush 'rsyslog.out.stats.log'
-echo doing shutdown
-. $srcdir/diag.sh shutdown-when-empty
-echo wait on shutdown
-. $srcdir/diag.sh wait-shutdown
-#. $srcdir/diag.sh dump-kafka-topic 'static' '.dep_wrk1' '2181'
-. $srcdir/diag.sh dump-kafka-topic 'static' '.dep_wrk2' '2182'
-. $srcdir/diag.sh dump-kafka-topic 'static' '.dep_wrk3' '2183'
-#. $srcdir/diag.sh stop-kafka '.dep_wrk1'
-. $srcdir/diag.sh stop-kafka '.dep_wrk2'
-. $srcdir/diag.sh stop-kafka '.dep_wrk3'
-. $srcdir/diag.sh custom-content-check 'msgnum:00000000' 'rsyslog.out.kafka.dep_wrk1.log'
-. $srcdir/diag.sh custom-content-check 'msgnum:00000001' 'rsyslog.out.kafka.dep_wrk2.log'
-. $srcdir/diag.sh custom-content-check 'msgnum:00000009' 'rsyslog.out.kafka.dep_wrk3.log'
-. $srcdir/diag.sh first-column-sum-check 's/.*submitted=\([0-9]\+\)/\1/g' 'omkafka' 'rsyslog.out.stats.log' 300000
-. $srcdir/diag.sh exit
diff --git a/tests/omkafka_static.sh b/tests/omkafka_static.sh
deleted file mode 100755
index c629036230..0000000000
--- a/tests/omkafka_static.sh
+++ /dev/null
@@ -1,25 +0,0 @@
-#!/bin/bash
-# added 2016-04-19 by singh.janmejay
-# This file is part of the rsyslog project, released under ASL 2.0
-echo ===============================================================================
-echo \[omkafka_static.sh\]: test for omkafka publishing to statically defined topic
-. $srcdir/diag.sh init
-. $srcdir/diag.sh download-kafka
-. $srcdir/diag.sh start-kafka
-. $srcdir/diag.sh create-kafka-topic 'static'
-. $srcdir/diag.sh startup omkafka_static.conf
-. $srcdir/diag.sh wait-for-stats-flush 'rsyslog.out.stats.log'
-. $srcdir/diag.sh injectmsg  0 10
-. $srcdir/diag.sh wait-queueempty
-. $srcdir/diag.sh wait-for-stats-flush 'rsyslog.out.stats.log'
-echo doing shutdown
-. $srcdir/diag.sh shutdown-when-empty
-echo wait on shutdown
-. $srcdir/diag.sh wait-shutdown
-. $srcdir/diag.sh dump-kafka-topic 'static'
-. $srcdir/diag.sh stop-kafka
-. $srcdir/diag.sh custom-content-check 'msgnum:00000000' 'rsyslog.out.kafka.log'
-. $srcdir/diag.sh custom-content-check 'msgnum:00000001' 'rsyslog.out.kafka.log'
-. $srcdir/diag.sh custom-content-check 'msgnum:00000009' 'rsyslog.out.kafka.log'
-. $srcdir/diag.sh first-column-sum-check 's/.*submitted=\([0-9]\+\)/\1/g' 'omkafka' 'rsyslog.out.stats.log' 10
-. $srcdir/diag.sh exit
diff --git a/tests/sndrcv_kafka.sh b/tests/sndrcv_kafka.sh
index 47ea10689a..168ed9e558 100755
--- a/tests/sndrcv_kafka.sh
+++ b/tests/sndrcv_kafka.sh
@@ -1,6 +1,8 @@
 #!/bin/bash
 # added 2017-05-03 by alorbach
 # This file is part of the rsyslog project, released under ASL 2.0
+export TESTMESSAGES=1000
+export TESTMESSAGESFULL=1000
 echo ===============================================================================
 echo \[sndrcv_kafka.sh\]: Create kafka/zookeeper instance and static topic
 . $srcdir/diag.sh download-kafka
@@ -10,11 +12,43 @@ echo \[sndrcv_kafka.sh\]: Create kafka/zookeeper instance and static topic
 . $srcdir/diag.sh start-kafka
 . $srcdir/diag.sh create-kafka-topic 'static' '.dep_wrk' '22181'
 
-echo \[sndrcv_kafka.sh\]: testing sending and receiving via kafka
-. $srcdir/sndrcv_drvr.sh sndrcv_kafka 10000
+echo \[sndrcv_kafka.sh\]: Give Kafka some time to process topic create ...
+sleep 5
 
-echo \[sndrcv_kafka.sh\]: stop kafka instance
+echo \[sndrcv_kafka.sh\]: Starting receiver instance [omkafka]
+export RSYSLOG_DEBUGLOG="log"
+. $srcdir/diag.sh init
+. $srcdir/diag.sh startup sndrcv_kafka_rcvr.conf 
+. $srcdir/diag.sh wait-startup
+
+echo \[sndrcv_kafka.sh\]: Starting sender instance [imkafka]
+export RSYSLOG_DEBUGLOG="log2"
+. $srcdir/diag.sh startup sndrcv_kafka_sender.conf 2
+. $srcdir/diag.sh wait-startup 2
+
+echo \[sndrcv_kafka.sh\]: Inject messages into rsyslog sender instance  
+. $srcdir/diag.sh tcpflood -m$TESTMESSAGES -i1
+
+echo \[sndrcv_kafka.sh\]: Sleep to give rsyslog instances time to process data ...
+sleep 5
+
+echo \[sndrcv_kafka.sh\]: Stopping sender instance [imkafka]
+. $srcdir/diag.sh shutdown-when-empty 2
+. $srcdir/diag.sh wait-shutdown 2
+
+echo \[sndrcv_kafka.sh\]: Sleep to give rsyslog receiver time to receive data ...
+sleep 5
+
+echo \[sndrcv_kafka.sh\]: Stopping receiver instance [omkafka]
+. $srcdir/diag.sh shutdown-when-empty
+. $srcdir/diag.sh wait-shutdown
+
+# Do the final sequence check
+. $srcdir/diag.sh seq-check 1 $TESTMESSAGESFULL -d
+
+echo \[sndrcv_kafka_fail.sh\]: stop kafka instance
 . $srcdir/diag.sh delete-kafka-topic 'static' '.dep_wrk' '22181'
 . $srcdir/diag.sh stop-kafka
-. $srcdir/diag.sh stop-zookeeper
 
+# STOP ZOOKEEPER in any case
+. $srcdir/diag.sh stop-zookeeper
diff --git a/tests/sndrcv_kafka_fail.sh b/tests/sndrcv_kafka_fail.sh
index 0adaeca15b..b706ad76e1 100755
--- a/tests/sndrcv_kafka_fail.sh
+++ b/tests/sndrcv_kafka_fail.sh
@@ -34,7 +34,6 @@ export RSYSLOG_DEBUGLOG="log2"
 echo \[sndrcv_kafka_fail.sh\]: Inject messages into rsyslog sender instance  
 . $srcdir/diag.sh tcpflood -m$TESTMESSAGES -i1
 
-
 echo \[sndrcv_kafka_fail.sh\]: Starting kafka cluster instance 
 . $srcdir/diag.sh start-kafka
 
@@ -59,7 +58,7 @@ echo \[sndrcv_kafka_fail.sh\]: Stopping receiver instance [omkafka]
 . $srcdir/diag.sh wait-shutdown
 
 # Do the final sequence check
-. $srcdir/diag.sh seq-check 1 $TESTMESSAGESFULL
+. $srcdir/diag.sh seq-check 1 $TESTMESSAGESFULL -d
 
 echo \[sndrcv_kafka_fail.sh\]: stop kafka instance
 . $srcdir/diag.sh delete-kafka-topic 'static' '.dep_wrk' '22181'
diff --git a/tests/sndrcv_kafka_failresume.sh b/tests/sndrcv_kafka_failresume.sh
new file mode 100755
index 0000000000..07649981f2
--- /dev/null
+++ b/tests/sndrcv_kafka_failresume.sh
@@ -0,0 +1,73 @@
+#!/bin/bash
+# added 2017-06-06 by alorbach
+#	This tests the keepFailedMessages feature in omkafka
+# This file is part of the rsyslog project, released under ASL 2.0
+export TESTMESSAGES=1000
+export TESTMESSAGESFULL=1000
+
+echo ===============================================================================
+echo \[sndrcv_kafka_failresume.sh\]: Create kafka/zookeeper instance and static topic
+. $srcdir/diag.sh download-kafka
+. $srcdir/diag.sh stop-zookeeper
+. $srcdir/diag.sh stop-kafka
+. $srcdir/diag.sh start-zookeeper
+. $srcdir/diag.sh start-kafka
+. $srcdir/diag.sh create-kafka-topic 'static' '.dep_wrk' '22181'
+
+echo \[sndrcv_kafka_failresume.sh\]: Give Kafka some time to process topic create ...
+sleep 5
+
+echo \[sndrcv_kafka_failresume.sh\]: Init Testbench 
+. $srcdir/diag.sh init
+
+echo \[sndrcv_kafka_failresume.sh\]: Starting receiver instance [omkafka]
+export RSYSLOG_DEBUGLOG="log"
+. $srcdir/diag.sh startup sndrcv_kafka_rcvr.conf 
+. $srcdir/diag.sh wait-startup
+
+echo \[sndrcv_kafka_failresume.sh\]: Starting sender instance [imkafka]
+export RSYSLOG_DEBUGLOG="log2"
+. $srcdir/diag.sh startup sndrcv_kafka_sender.conf 2
+. $srcdir/diag.sh wait-startup 2
+
+echo \[sndrcv_kafka_failresume.sh\]: Inject messages into rsyslog sender instance  
+. $srcdir/diag.sh tcpflood -m$TESTMESSAGES -i1
+
+echo \[sndrcv_kafka_failresume.sh\]: Stopping kafka cluster instance 
+. $srcdir/diag.sh stop-kafka
+
+echo \[sndrcv_kafka_failresume.sh\]: Stopping sender instance [imkafka]
+. $srcdir/diag.sh shutdown-when-empty 2
+. $srcdir/diag.sh wait-shutdown 2
+
+echo \[sndrcv_kafka_failresume.sh\]: Starting kafka cluster instance 
+. $srcdir/diag.sh start-kafka
+
+echo \[sndrcv_kafka_failresume.sh\]: Starting sender instance [imkafka]
+export RSYSLOG_DEBUGLOG="log3"
+. $srcdir/diag.sh startup sndrcv_kafka_sender.conf 2
+. $srcdir/diag.sh wait-startup 2
+
+echo \[sndrcv_kafka_failresume.sh\]: Sleep to give rsyslog sender time to send data ...
+sleep 10
+
+echo \[sndrcv_kafka_failresume.sh\]: Stopping sender instance [imkafka]
+. $srcdir/diag.sh shutdown-when-empty 2
+. $srcdir/diag.sh wait-shutdown 2
+
+echo \[sndrcv_kafka_failresume.sh\]: Sleep to give rsyslog receiver time to receive data ...
+sleep 5
+
+echo \[sndrcv_kafka_failresume.sh\]: Stopping receiver instance [omkafka]
+. $srcdir/diag.sh shutdown-when-empty
+. $srcdir/diag.sh wait-shutdown
+
+# Do the final sequence check
+. $srcdir/diag.sh seq-check 1 $TESTMESSAGESFULL
+
+echo \[sndrcv_kafka_failresume.sh\]: stop kafka instance
+. $srcdir/diag.sh delete-kafka-topic 'static' '.dep_wrk' '22181'
+. $srcdir/diag.sh stop-kafka
+
+# STOP ZOOKEEPER in any case
+. $srcdir/diag.sh stop-zookeeper
diff --git a/tests/sndrcv_kafka_multi.sh b/tests/sndrcv_kafka_multi.sh
index 959e7b005b..6b6e1f333e 100755
--- a/tests/sndrcv_kafka_multi.sh
+++ b/tests/sndrcv_kafka_multi.sh
@@ -46,7 +46,7 @@ echo \[sndrcv_kafka_multi.sh\]: Stopping receiver instance [imkafka]
 . $srcdir/diag.sh wait-shutdown 2
 
 # Do the final sequence check
-. $srcdir/diag.sh seq-check 1 $TESTMESSAGES
+. $srcdir/diag.sh seq-check 1 $TESTMESSAGES -d
 
 echo \[sndrcv_kafka.sh\]: stop kafka instances
 . $srcdir/diag.sh delete-kafka-topic 'static' '.dep_wrk1' '22181'
diff --git a/tests/testsuites/omkafka_multiple.conf b/tests/testsuites/omkafka_multiple.conf
deleted file mode 100644
index 53cac1ab1a..0000000000
--- a/tests/testsuites/omkafka_multiple.conf
+++ /dev/null
@@ -1,18 +0,0 @@
-$IncludeConfig diag-common.conf
-
-module(load="../plugins/omkafka/.libs/omkafka")
-
-ruleset(name="stats") {
-  action(type="omfile" file="./rsyslog.out.stats.log")
-}
-
-module(load="../plugins/impstats/.libs/impstats" interval="1" severity="7" resetCounters="on" Ruleset="stats" bracketing="on")
-
-template(name="outfmt" type="string" string="%msg%\n")
-
-if ($msg contains "msgnum") then {
-	 action(name="kafka-fwd" type="omkafka" topic="static" broker=["localhost:9092", "localhost:9093", "localhost:9094"] template="outfmt" partitions.auto="on")
-#	 action(name="kafka-fwd" type="omkafka" topic="static" broker="localhost:9092" template="outfmt" partitions.auto="on")
-#	 action(name="kafka-fwd" type="omkafka" topic="static" broker="localhost:9093" template="outfmt" partitions.auto="on")
-#	 action(name="kafka-fwd" type="omkafka" topic="static" broker="localhost:9094" template="outfmt" partitions.auto="on")
-}
diff --git a/tests/testsuites/omkafka_static.conf b/tests/testsuites/omkafka_static.conf
deleted file mode 100644
index 46e5cdf3a0..0000000000
--- a/tests/testsuites/omkafka_static.conf
+++ /dev/null
@@ -1,15 +0,0 @@
-$IncludeConfig diag-common.conf
-
-module(load="../plugins/omkafka/.libs/omkafka")
-
-ruleset(name="stats") {
-  action(type="omfile" file="./rsyslog.out.stats.log")
-}
-
-module(load="../plugins/impstats/.libs/impstats" interval="1" severity="7" resetCounters="on" Ruleset="stats" bracketing="on")
-
-template(name="outfmt" type="string" string="%msg%\n")
-
-if ($msg contains "msgnum") then {
-	 action(name="kafka-fwd" type="omkafka" topic="static" broker="localhost" template="outfmt" partitions.auto="on")
-}
diff --git a/tests/testsuites/sndrcv_kafka_multi_sender.conf b/tests/testsuites/sndrcv_kafka_multi_sender.conf
index 20c4255454..95006fc1a0 100644
--- a/tests/testsuites/sndrcv_kafka_multi_sender.conf
+++ b/tests/testsuites/sndrcv_kafka_multi_sender.conf
@@ -12,6 +12,12 @@ ruleset(name="omkafka") {
 		broker=["localhost:29092", "localhost:29093", "localhost:29094"] 
 		topic="static" 
 		template="outfmt" 
+		confParam=[	"compression.codec=snappy",
+				"socket.timeout.ms=1000",
+				"socket.keepalive.enable=true",
+				"reconnect.backoff.jitter.ms=1000",
+				"queue.buffering.max.messages=20000",
+				"message.send.max.retries=1"]
 		partitions.auto="on"
 		partitions.scheme="random"
 		queue.size="1000000"
diff --git a/tests/testsuites/sndrcv_kafka_sender.conf b/tests/testsuites/sndrcv_kafka_sender.conf
index 08bede6070..7012642fe7 100644
--- a/tests/testsuites/sndrcv_kafka_sender.conf
+++ b/tests/testsuites/sndrcv_kafka_sender.conf
@@ -15,7 +15,7 @@ action(	name="kafka-fwd"
 			"socket.timeout.ms=1000",
 			"socket.keepalive.enable=true",
 			"reconnect.backoff.jitter.ms=1000",
-			"queue.buffering.max.messages=10000",
+			"queue.buffering.max.messages=20000",
 			"message.send.max.retries=1"]
 	topicConfParam=["message.timeout.ms=1000"]
 	partitions.auto="on"
